;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
;
; math routines
;
	include hv.inc
	
	; variables
	extern	rand,d1
	
	
math_code	CODE
	
; 
; initialize random generator
;
init_random
	GLOBAL	init_random
	movff	TMR1H,rand+1
	movff	TMR1L,rand
	bz	ir_0
	return
ir_0	movlw	0xA6
	movwf	rand
	return
	
; 
; random generator : LFSR (16 bits)
; polynom is 0xA1A1
;
random
	GLOBAL	random
	bcf	STATUS,C
	rrcf	rand+1,f
	rrcf	rand,f
	btfss	STATUS,C
	return
	movlw	0xA1
	xorwf	rand+1,f
	xorwf	rand,f
	movf	rand,w
	return
	

; generate a random number between 0 and 9	
rand_10
	GLOBAL	rand_10
	call	random
	andlw	0x0F		; 0 <= W < 16
	movwf	d1
	movlw	0xA
	subwf	d1,w
	btfsc	STATUS,C
	movwf	d1
	movf	d1,w
	return


; generate a random number between 0 and W, W max being 0xF.
rand_W_16
	GLOBAL	rand_W_16
	bz	ret0		; if 0, return 0.
	movwf	d1		; d1 = max random value
	call	random
	andlw	0x0F		; 0 <= W < 16
rw16	cpfslt	d1		; while (max < rand)
	return
	bsf	STATUS,C
	subfwb	d1,w		; 	rand -= max
	bra	rw16
ret0	retlw	.0

	END
	
